/* 
* Based on: 
* Arduino Wireless Communication Tutorial Example 1 - Transmitter Code by Dejan Nedelkovski, www.HowToMechatronics.com
*/

#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>
#include <Servo.h>  // cannot do without you

//radio setup
RF24 radio(7, 8); // CE, CSN
const byte address[6] = "00001";
// servo setup
Servo myservo;                    // our instance of servo class
#define servoPin 9                // setting up the communications
int myServoValue = 0;             // storing the angle

//motor setup
int motorPin = 3;
int runEng = 0;
int sp = 255;
//boolean runEngine = 0;

struct Data_Package
{
  byte engSpeed;
  byte serAngle;
  byte windBlow;    // wip
};
Data_Package data;

void setup() 
{
  Serial.begin(9600);                         // 
  
  radio.begin();                              // radio init
  radio.openReadingPipe(0, address);          // 
  radio.setPALevel(RF24_PA_MIN);    
  radio.startListening();

  resetData();
  pinMode(motorPin, OUTPUT);
  
  myservo.attach(servoPin);                   // servo init
}

void loop() 
{
  radio.startListening();
  if (radio.available())  //check if there is a transmission
  {
    if (radio.available()) 
    {
      radio.read(&data, sizeof(Data_Package)); // Read the whole data and store it into the 'data' structure
      analogWrite(motorPin, data.engSpeed);
      //analogWrite(servoPin, data.angSer);
      analogWrite(servoPin, data.windBlow);
      myServoValue = map(data.serAngle, 0, 255, 45, 135);
      myservo.write(myServoValue);
    }
      
  }
  else
  {
    resetData();
    digitalWrite(LED_BUILTIN, HIGH);   // turn the LED on (HIGH is the voltage level)
    delay(2000);                       // wait for a second
    digitalWrite(LED_BUILTIN, LOW);    // turn the LED off by making the voltage LOW
    delay(500);
  }
  delay(50);
  
  //servo1Value = map(data.j2PotX, 0, 255, 0, 180);
  //servo1.write(servo1Value);
}

void resetData() 
{
  // Reset the values when there is no radio connection - Set initial default values
  data.engSpeed = 0;  // init speed 0 to make it easier (range 0 to 255)
  data.serAngle = 127;  // init position of the steering wheel also 0 (0 to 255, 127 is middle)
  data.windBlow = 0;  // init blow of air set to 0  (range 0 to 255)
}
